// liveinfo.js
// 12/11/03 v0.2mod
//
// v0.2からの変更点
//   【バグ修正】
//     ニコ生Qでckeyが取得できなくなっていたのを修正
//   【機能追加】
//     名前付きマイリストに登録できるようにした
//     海外タグも表示するように
//     投稿者名を取得して表示するようにした


(function() {
	var id = new Array(liveinfo_listNum);
	var title = new Array(liveinfo_listNum);
	var count = new Array(liveinfo_listNum);
	var comment = new Array(liveinfo_listNum);
	var mylist = new Array(liveinfo_listNum);
	var length = new Array(liveinfo_listNum);
	var date = new Array(liveinfo_listNum);
	var desc = new Array(liveinfo_listNum);
	var tags = new Array(liveinfo_listNum);
	var user_id = new Array(liveinfo_listNum);
	var user_name = new Array(liveinfo_listNum);
	var isCache = new Array(liveinfo_listNum);
	var mylist_flag = new Array(liveinfo_listNum);
	var holder = 0;
	var mg;
	var liveinfo_community_id="";
// liveinfo機能を自動で起動するかどうかチェック
	function checkliveinfo(){
		if(typeof getGPS==="function"||typeof Nicolive_JS_Conf.GPS.value_by_gps==="string"){
			var LI_GPS=getGPS()||decodeURIComponent(Nicolive_JS_Conf.GPS.value_by_gps);
			if(LI_GPS.match(/<default_community>([^<]+)<\/default_community>/))
				liveinfo_community_id = RegExp.$1;
			return typeof LI_GPS==="string"&&/(<category>動画紹介<\/category>|<is_ns_stream>\d+<\/is_ns_stream>)/.test(LI_GPS);
		}
		return false;
	}
// mylistgroupを取得
	window.liveinfo_getmylistgroup=function(){
		new Ajax.Request("http://" + location.host + "/liveinfo_www.nicovideo.jp/api/mylistgroup/list",{
			method: 'get',
			onSuccess: function(httpObj){
				mg=eval("("+httpObj.responseText+")");
				// 2秒ごとにリストを取得、更新されてたらページ書き換えとか
				window.liveinfo_handle = setInterval(getLiveList, 2000);
			}
		});
	};
// メイン関数。これ呼べばデータ取得･アップデート
// Extensionから動画リスト取得して処理にまわす
	function getLiveList() {
		new Ajax.Request("http://live.nicovideo.jp/cache/liveinfo",{
			method: 'get',
			onSuccess: getLiveListResponce
		});
	}
// リストが更新されてたらデータ取得とか表示更新とか
	function getLiveListResponce(httpObj) {
		if (httpObj.responseText != "") {
			var list = httpObj.responseText.split(",");
			if (list[0] == "" || list[0] == id[holder]) return;
			holder = (holder+1)%liveinfo_listNum;
			id[holder] = list[0];
			isCache[holder] = list[1];
			title[holder] = undefined;
			getData();
		}
	}
// thumbinfoからデータ取得
	function getData() {
		new Ajax.Request("http://" + location.host + "/liveinfo_ext.nicovideo.jp/api/getthumbinfo/"+id[holder], {
			method: "get",
			onSuccess: getDataResponse
		});
	}
	function getDataResponse(httpObj) {
		title[holder] = "unknown";
		count[holder] = "";
		comment[holder] = "";
		mylist[holder] = "";
		length[holder] = "";
		user_id[holder] = "";
		user_name[holder] = "";
		date[holder] = "";
		desc[holder] = "";
		tags[holder] = new Array();
		mylist_flag[holder] = -1;
		var taghtml = "";
		httpObj.responseText.replace(/<title>(.+)<\/title>/,function(s0,s1){
			title[holder] = s1.replace(/&apos;/g,"'").replace(/&amp;/g,"&").replace(/&nbsp;/g,"");
			return s0;
		}).replace(/<view_counter>(.+)<\/view_counter>/,function(s0,s1){
			count[holder] = s1;
			return s0;
		}).replace(/<comment_num>(.+)<\/comment_num>/,function(s0,s1){
			comment[holder] = s1;
			return s0;
		}).replace(/<mylist_counter>(.+)<\/mylist_counter>/,function(s0,s1){
			mylist[holder] = s1;
			return s0;
		}).replace(/<length>(.+)<\/length>/,function(s0,s1){
			length[holder] = s1;
			return s0;
		}).replace(/<user_id>(.+)<\/user_id>/,function(s0,s1){
			user_id[holder] = s1;
			return s0;
		}).replace(/<first_retrieve>(\d+)-(\d+)-(\d+)T(\d+:\d+:\d+)\+09:00<\/first_retrieve>/,function(s0,s1,s2,s3,s4){
			date[holder] = s1+"/"+s2+"/"+s3+" "+s4;
			return s0;
		}).replace(/<description>([\s\S]+)<\/description>/,function(s0,s1){
			desc[holder] = s1.replace(/&apos;/g,"'").replace(/&amp;/g,"&").replace(/&nbsp;/g,"");
			return s0;
		}).replace(/<tags domain="jp">([\s\S]+?)<\/tags>/,function(s0,s1){
			taghtml += "<br><span style='color:blue;'>"
			+(s1.replace(/<tag[^>]*>([^<]+)<\/tag>/g,function(t0,t1){
				tags[holder][tags[holder].length]=t1;return t0;
			}).replace(/<tag[^>]*>/g,"　").replace(/<\/tag>/g,""))+"</span>";
			return s0;
		}).replace(/<tags domain="(tw|de|es)">([\s\S]+?)<\/tags>/g,function(s0,s1,s2){
			if(liveinfo_showoverseatags){
				taghtml += "<br><span style='color:green;'>"
				+(s2.replace(/<tag[^>]*>([^<]+)<\/tag>/g,function(t0,t1){
					tags[holder][tags[holder].length]=t1;return t0;
				}).replace(/<tag[^>]*>/g,"　").replace(/<\/tag>/g,""))+"</span>";
			}
			return s0;
		});
		desc[holder] += taghtml;

		nlGetTag();
	}
	function nlGetTag(){
		if(liveinfo_getTagFlg)
			new Ajax.Request("http://" + location.host + "/liveinfo_www.nicovideo.jp/cache/taglist?id=" + id[holder] + "&tag=" + encodeURIComponent(tags[holder].join(' ')) + "&time="+(new Date).getTime(), {
				method: "get",
				onSuccess: function(httpObj){
					getUsername();
				}
			});
		else
			getUsername();
	}
	function getUsername() {
		if(user_id[holder]=="")
			updateView();
		else
			new Ajax.Request("http://" + location.host + "/liveinfo_ext.nicovideo.jp/thumb_user/"+user_id[holder], {
				method: "get",
				onSuccess: function(httpObj){
					if(httpObj.responseText.match(/<p class="TXT12"><a[^>]+><strong>(.+)<\/strong><\/a><\/p>/))
						user_name[holder] = RegExp.$1;
					updateView();
				}
			});
	}
// 表示を更新する
	function updateView() {
		var infoList = $("nl_liveInfoList");
		var str = '<p align="right" style="background-color: white;">マイリスト登録先：<select id="addMylistTarget"><option value="0">とりあえずマイリスト</option>';
		for(var i=0,_mg;_mg=mg.mylistgroup[i];i++)
			str+='<option value="'+_mg.id+'">'+_mg.name+'</option>';
		str+='</select><input id="liveinfo_addMylistComment" typw="text" size="50" value="'+
			liveinfo_addMylistCommentTemplete
					.replace(/{com_id}/ig,liveinfo_community_id)
					.replace(/{title}/ig,Video.title.replace(/\u200b/g,""))
					.replace(/{lv}/ig,Video.id)+'"></p>';
		for (var i=liveinfo_listNum; i>0; i--)
			if (title[(holder+i)%liveinfo_listNum])
				str += getInfoLine((holder+i)%liveinfo_listNum);
		infoList.innerHTML = str;
	}
// movieFetcherとかマイリス登録後の処理とかも埋め込む
	function getInfoLine(holder_id) {
		var str = '<table style="width:100%;"><tr style="background-color: white;"><td width="13%">'+id[holder_id];
		if (nicofetch && isCache[holder_id] != "cache")
			str += '<a href="javascript:void(0)" onclick="nicofetch(this,\''+id[holder_id]+'\',2)" style="font-size:10px;">(fetch)</a>';
		str += '</td><td>'+
			'<a href="http://www.nicovideo.jp/watch/'+id[holder_id]+'" target="_blank" onmouseover="$(\'nl_'+id[holder_id]+'\').style.display=\'\'" onmouseout="$(\'nl_'+id[holder_id]+'\').style.display=\'none\'"';
		if (isCache[holder_id] == "cache")
			str += ' style="color:#C00000"';
		else if (isCache[holder_id] == "low")
			str += ' style="color:#C08000"';
		str += '>'+title[holder_id]+'</a></td>'+
			'<td width="3%">再生</td><td width="7%">'+count[holder_id]+'</td>'+
			'<td width="3%">投稿</td><td width="7%"><a href="http://www.nicovideo.jp/user/'+user_id[holder_id]+'" target="_blank" title="'+user_name[holder_id]+'さんのユーザーページへ">'+user_name[holder_id]+'</a></td>';
		if (mylist_flag[holder_id] < 0)
			str += '<td width="5%"><a href="javascript:void(0)" onclick="addmylist(\''+id[holder_id]+'\'); return false;">登録</a></td>'
		else if (mylist_flag[holder_id] == 1)
			str += '<td width="5%">登録(済)</td>';
		else
			str += '<td width="5%">登録(失)</td>';
		str += '<td width="7%">'+mylist[holder_id]+'</td>'+
			'<td width="3%">コメ</td><td width="7%">'+comment[holder_id]+'</td>'+
			'<td width="3%">長さ</td><td width="7%">'+length[holder_id]+'</td></tr></table>';
// 動画説明文
		str+='<div id="nl_'+id[holder_id]+'" style="width:920px; position:absolute; background-color:#ffffd0; border:1px solid gray; display:none;z-index:9;">投稿：'+date[holder_id]+"<br>"+desc[holder_id]+'</div>';
		return str;
	}
	
	var addMylistCompleteXML = '<?xml version="1.0" encoding="utf-8"?>\n<addmylist status="ok"/>';
	var addMylistExistErrXML = '<?xml version="1.0" encoding="utf-8"?>\n<addmylist status="fail"><error><code>EXIST</code></error></addmylist>';
	var addMylistResultXML='';
// マイリスト追加処理をhookして、thread_idが無いときはgetflvから取得
	window.addmylist = function(smid,thread_id) {
		var group_id = $("addMylistTarget").value;
		new Ajax.Request("http://" + location.host + "/liveinfo_www.nicovideo.jp/mylist_add/video/"+smid, {
			method: "get",
			onSuccess: function(r){
				var token;
				r.responseText
					.replace(/NicoAPI\.token\s*=\s*\"(.*)\";/,function(s0,s1){
						token=s1;
					}).replace(/item_id\"\s*value=\"(.*)\">/,function(s0,s1){
						if(!thread_id)thread_id=s1;
					});
				if(!token||!thread_id){
					for (var i=0; i<liveinfo_listNum; i++) {
						if (smid == id[(holder+i)%liveinfo_listNum]){
							mylist_flag[(holder+i)%liveinfo_listNum] = 2;
							break;
						}
					}
					updateView();
					return false;
				}
				for (var i=0; i<liveinfo_listNum; i++) {
					if (smid == id[(holder+i)%liveinfo_listNum]){
						mylist_flag[(holder+i)%liveinfo_listNum] = 0;
						break;
					}
				}
				var description = $("liveinfo_addMylistComment").value;
				var url = "http://" + location.host + "/liveinfo_www.nicovideo.jp/api/"+(group_id==0?"deflist":"mylist")+"/add"
				new Ajax.Request(url, {
					method: "post",
					parameters: (group_id==0?"":("group_id="+group_id+"&"))+"item_type=0&item_id="+encodeURIComponent(thread_id)+"&description="+encodeURIComponent(description)+"&token="+encodeURIComponent(token),
					onSuccess: window.addmylistResult
				});
			}
		});
	};
	window.addmylistResult = function(xmlHttp) {
		var resJson=eval("("+xmlHttp.responseText+")");
		addMylistResultXML = resJson.status=="ok"?addMylistCompleteXML:resJson.error.code=="EXIST"?addMylistExistErrXML:"";
		var result = resJson.status=="ok"?1:2;
		for (var i=0; i<liveinfo_listNum; i++) {
			if (mylist_flag[(holder+i)%liveinfo_listNum] == 0){
				mylist_flag[(holder+i)%liveinfo_listNum] = result;
				break;
			}
		}
		try{
			if(addMylistResultXML!='')
				$("flvplayer").setAddmylistResult(addMylistResultXML);
		}catch(e){
		}finally{
			updateView();
		}
	};
	Event.observe(window, "load", function(){
		var _elm = $("player_btm")||$("watch_player_bottom_box");
		_elm.insert({after: '<div id="nl_liveInfoList"></div>'});
		var flag = checkliveinfo();
		if(flag){
			liveinfo_getmylistgroup();
		} else {
			$("nl_liveInfoList").innerHTML = '<input type="button" value="liveinfoを起動する" onclick="liveinfo_getmylistgroup()">';
		}
	}, false);
})();
